# Class PropertyEditorManager

java.lang.Object
java.beans.PropertyEditorManager

public class PropertyEditorManager extends Object
The PropertyEditorManager can be used to locate a property editor for any given type name. This property editor must support the java.beans.PropertyEditor interface for editing a given object.

The PropertyEditorManager uses three techniques for locating an editor for a given type. First, it provides a registerEditor method to allow an editor to be specifically registered for a given type. Second it tries to locate a suitable class by adding "Editor" to the full qualified classname of the given type (e.g. "foo.bah.FozEditor"). Finally it takes the simple classname (without the package name) adds "Editor" to it and looks in a search-path of packages for a matching class.

So for an input class foo.bah.Fred, the PropertyEditorManager would first look in its tables to see if an editor had been registered for foo.bah.Fred and if so use that. Then it will look for a foo.bah.FredEditor class. Then it will look for (say) standardEditorsPackage.FredEditor class.

Default PropertyEditors will be provided for the Java primitive types "boolean", "byte", "short", "int", "long", "float", and "double"; and for the classes java.lang.String. java.awt.Color, and java.awt.Font.

Since:
  1.1

## Constructor Summary

Constructors
Constructor
Description
`PropertyEditorManager()`
Constructs a `PropertyEditorManager`.

## Method Summary

Modifier and Type
Method
Description
`static PropertyEditor`
`findEditor(Class<?> targetType)`
Locate a value editor for a given target type.
`static String[]`
`getEditorSearchPath()`
Gets the package names that will be searched for property editors.
`static void`
`registerEditor(Class<?> targetType, Class<?> editorClass)`
Registers an editor class to edit values of the given target class.
`static void`
`setEditorSearchPath(String[] path)`
Change the list of package names that will be used for finding property editors.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### PropertyEditorManager

public PropertyEditorManager()
Constructs a `PropertyEditorManager`.

## Method Details

### registerEditor

public static void registerEditor(Class<?> targetType, Class<?> editorClass)
Registers an editor class to edit values of the given target class. If the editor class is `null`, then any existing definition will be removed. Thus this method can be used to cancel the registration. The registration is canceled automatically if either the target or editor class is unloaded.

Parameters:
  `targetType` - the class object of the type to be edited
  `editorClass` - the class object of the editor class

### findEditor

public static PropertyEditor findEditor(Class<?> targetType)
Locate a value editor for a given target type.

Parameters:
  `targetType` - The Class object for the type to be edited
Returns:
  An editor object for the given target class. The result is null if no suitable editor can be found.

### getEditorSearchPath

public static String[] getEditorSearchPath()
Gets the package names that will be searched for property editors.

Returns:
  The array of package names that will be searched in order to find property editors.

  The default value for this array is implementation-dependent, e.g. Sun implementation initially sets to {"sun.beans.editors"}.

### setEditorSearchPath

public static void setEditorSearchPath(String[] path)
Change the list of package names that will be used for finding property editors.

Parameters:
  `path` - Array of package names.